
# TODO 追加没有参数符号和开关型的参数支持
module LTools
  class Tool
		class ToolOpts
      def self.build(&block)
        new(&block).to_s
      end

			def initialize
				@args = []
				yield self if block_given?
			end

			def on(opt, value, &block)
				if value
					value = block.call(value) if block
					if value
            @args << opt if opt
            @args << value
					end
				end
			end

			def to_s
        to_str
			end

      def to_str
				" #{Shellwords.join(@args)} "
      end

			def to_a
				@args
			end
		end
	end
end
